#include <PID_v1.h>

int Pot1 = A2;

int BlueLed = 2;
int GreenLed = 3;
int RedLed = 4;

int RPWM_Output = 6; // Arduino PWM output pin 6; connect to IBT-2 pin 1 (RPWM)
int LPWM_Output = 5; // Arduino PWM output pin 5; connect to IBT-2 pin 2 (LPWM)
int Ren = 9;         // Enabling Right motion
int Len = 10;        // Enabling Left motion
int LPWM;
int RPWM;

int RX = 7; // Channel1 value
int RXValue;
int RXValueMapped;
int RXActive;

String SetpointString;

double Setpoint;
double Input;
double Output;

unsigned long PrMillis;
unsigned long Timer;

int BlinkVal = 500;
int BlinkVal2 = 100;


void setup() 
{
  pinMode(BlueLed, OUTPUT);
  pinMode(GreenLed, OUTPUT);
  pinMode(RedLed, OUTPUT);
  
  pinMode(RPWM_Output, OUTPUT);
  pinMode(LPWM_Output, OUTPUT);
  pinMode(Ren, OUTPUT);
  pinMode(Len, OUTPUT);
  pinMode(RX, INPUT);

  /*digitalWrite(BlueLed, LOW);
  digitalWrite(GreenLed, LOW);
  digitalWrite(RedLed, LOW);
  delay(BlinkVal);
  digitalWrite(RedLed, HIGH);
  delay(BlinkVal);
  digitalWrite(RedLed, LOW);
  delay(BlinkVal);
  digitalWrite(RedLed, HIGH);
  delay(BlinkVal);
  digitalWrite(RedLed, LOW);
  delay(BlinkVal);
  digitalWrite(RedLed, HIGH);
  delay(BlinkVal);
  digitalWrite(RedLed, LOW);
  delay(BlinkVal);
  */
  
  Input = analogRead(Pot1);
  Setpoint = 500;

  Serial.begin(9600);
}
void loop() 
{
  Input = analogRead(Pot1);

  RXValue = pulseIn (RX, HIGH, 50000);
  RXValueMapped = map(RXValue, 1000, 1900, 300, 700);
  Setpoint = RXValueMapped;

  Output = Setpoint - Input;

  if (RXValue < 1900 && RXValue > 1000){
    digitalWrite(Ren, HIGH);
    digitalWrite(Len, HIGH);
    digitalWrite(RedLed, LOW);
    analogWrite(GreenLed, 5);
    RXActive = true;
  }
  else{
    digitalWrite(Ren, LOW);
    digitalWrite(Len, LOW);
    digitalWrite(RedLed, HIGH);
    digitalWrite(GreenLed, LOW);
    RXActive = false;
    LPWM = 0;
    RPWM = 0;
    Setpoint = Input;
    Output = 0;
  }

  while(Serial.available()) {
    SetpointString = Serial.readString();
    Setpoint = SetpointString.toDouble();
  }

  if (Output < -10 && Output > -100 && RXActive == true)
  {
    // reverse rotation
    RPWM = 30;
    LPWM = 0;
    digitalWrite(Ren, HIGH);
    analogWrite(LPWM_Output, 0);
    analogWrite(RPWM_Output, RPWM);
  }

  else if (Output < -101 && Output > -200 && RXActive == true)
  {
    // reverse rotation
    RPWM = 100;
    LPWM = 0;
    digitalWrite(Ren, HIGH);
    analogWrite(LPWM_Output, 0);
    analogWrite(RPWM_Output, RPWM);
  }

  else if (Output < -201  && RXActive == true)
  {
    // reverse rotation
    RPWM = 255;
    LPWM = 0;
    digitalWrite(Ren, HIGH);
    analogWrite(LPWM_Output, 0);
    analogWrite(RPWM_Output, RPWM);
  }

  
  else if (Output > 10 && Output < 100 && RXActive == true)
  {
    // forward rotation
    LPWM = 30;
    RPWM = 0;
    digitalWrite(Len, HIGH);
    analogWrite(LPWM_Output, LPWM);
    analogWrite(RPWM_Output, 0);
  }

  else if (Output > 101 && Output < 200 && RXActive == true)
  {
    // forward rotation
    LPWM = 100;
    RPWM = 0;
    digitalWrite(Len, HIGH);
    analogWrite(LPWM_Output, LPWM);
    analogWrite(RPWM_Output, 0);
  }

  else if (Output > 201 && RXActive == true)
  {
    // forward rotation
    LPWM = 255;
    RPWM = 0;
    digitalWrite(Len, HIGH);
    analogWrite(LPWM_Output, LPWM);
    analogWrite(RPWM_Output, 0);
  }

  else if (Output > -19 && Output < 19 && RXActive == true)
  {
    // forward rotation
    LPWM = 0;
    RPWM = 0;
    digitalWrite(Len, LOW);
    digitalWrite(Ren, LOW);
    analogWrite(LPWM_Output, 0);
    analogWrite(RPWM_Output, 0);
  }
  

  Serial.print("Input = ");
  Serial.print(Input);
  Serial.print("  Setpoint = ");
  Serial.print(Setpoint);
  Serial.print("  Output = ");
  Serial.print(Output);
  Serial.print("  RPWM = ");
  Serial.print(RPWM);
  Serial.print("  LPWM = ");
  Serial.print(LPWM);
  Serial.print("  RXVal = ");
  Serial.println(RXValueMapped);
  //Serial.print("  timer = ");
  //Serial.println(Timer);

}
